Description

This is a guide on installing Redmine with MariaDB and Nginx on FreeBSD 10.

Prepare the Environment

* Make sure that pkg is set to use the latest packages. Create the pkg repo config file:
mkdir -p /usr/local/etc/pkg/repos
vi /usr/local/etc/pkg/repos/FreeBSD.conf

o And add the following:

FreeBSD: {
url: "pkg+http://pkg.FreeBSD.org/${ABI}/latest",
mirror_type: "srv",
signature_type: "fingerprints",
fingerprints: "/usr/share/keys/pkg",
enabled: yes

e Make sure everything is up to date using the following command:

pkg update —-f && pkg upgrade
e Create a redmine user:

pw add user -n redmine -m -s /sbin/nologin -c "Redmine"
e |nstall a few dependencies:

pkg install portmaster gcc 1llvm36 cmake scons ImageMagick rubygem-mime-typesl rubygem-sass-rai
1s

Install MariaDB server

e Start by installing the mariadb100-server and mariadb100-client packages:

pkg install mariadbl00-{server,client}

® Copy a base MariaDB configuration to use:

04/19/2024 1/6




cp /usr/local/share/mysqgl/my-small.cnf /var/db/mysqgl/my.cnf

e Edit the mariadb config to change the max packet size:

vi /var/db/mysgl/my.cnf

o and modify max_allowed_packet to 32M

max_allowed_packet = 32M

e Enable and start MariaDB

echo 'mysqgl_enable="YES"' >> /etc/rc.conf
service mysgl-server start

e Prepare the database for use by running the secure installation:

mysqgl_secure_installation

o NOTE: Choose a strong root password and answer yes to all questions.

Create MariaDB Databases and Users

® Login to MariaDB and create appropriate databases and users.

mysgl —-u root -p

o and run the following SQL queries to create the redminedb database and redmineuser user:

CREATE DATABASE redminedb CHARACTER SET utfs8;

CREATE USER 'redmineuser'@'localhost' IDENTIFIED BY 'SuperSecretPassword';
GRANT ALL PRIVILEGES ON redminedb.* TO 'redmineuser'@'localhost';

FLUSH PRIVILEGES;

quit

Install Redmine

o |nstall redmine:

portmaster www/redmine

o NOTE: Make sure to enable [X]PASSENGER while configuring redmine

e Copy config/database.yml.example to config/database.yml:

cp /usr/local/www/redmine/config/database.yml.example /usr/local/www/redmine/config/database.y
ml
e Edit the redmine database config:

vi /usr/local/www/redmine/config/database.yml

o And modify the production database settings:

production:
adapter: mysqgl2
database: redminedb
host: localhost
username: redmineuser
password: "SuperSecretPassword"
encoding: utfs8

e |nstall gem dependencies:

cd /usr/local/www/redmine
bundle install --without development test postgres —--path vendor/bundle

e Generate a secret token:

bundle exec rake generate_secret_token

e Create the database structure:

env RAILS_ENV=production bundle exec rake db:migrate

e Change the redmine site ownership:

chown -R redmine:www /usr/local/www/redmine

Install Nginx

e Install nginx with passenger support:

portmaster www/nginx
o NOTE: Make sure to enable [X]PASSENGER while configuring nginx
¢ Install Passenger
portmaster www/rubygem-passenger
o NOTE: Make sure to enable [X]NGINX while configuring rubygem-passenger
o NOTE: Enabling [X]SYMLINK makes upgrading passenger easier later on.

e Add the redmine user to the www group:

pw usermod redmine -G www
e Start and enable nginx at boot:

echo 'nginx_enable="YES"' >> /etc/rc.conf
service nginx start

e Create a configuration directory to make managing individual server blocks easier

mkdir /usr/local/etc/nginx/conf.d

e Edit the main nginx config file:

vi /usr/local/etc/nginx/nginx.conf
o And strip down the config file and add the include statement at the end to make it easier to handle various server blocks:
worker_processes 1;
error_log /var/log/nginx-error.log;

events {
worker_connections 1024;

http {
include mime.types;
default_type application/octet-stream;
sendfile on;

keepalive_timeout 65;

# Load Phusion Passenger module globally

passenger_root /usr/local/lib/ruby/gems/2.2/gems/passenger;
passenger_ruby /usr/local/bin/ruby22;
passenger_max_pool_size 15;

passenger_pool_idle_time 300;

# Load config files from the /etc/nginx/conf.d directory
include /usr/local/etc/nginx/conf.d/*.conf;

¢ Add a redmine.example.com server block:

vi /usr/local/etc/nginx/conf.d/redmine.example.com.conf

o Add the following:

server {
listen 80;
server_name redmine.example.com;
root /usr/local/www/redmine/public;
access_log /var/log/redmine.example.com-access.log;
error_log /var/log/redmine.example.com-error.log;

passenger_enabled on;
passenger_user redmine;
passenger_group redmine;
® Restart nginx:

service nginx restart

e Open a web browser and go to http:/redmine.example.com. The admin username is admin and password is admin.

Resources

¢ http://www.redmine.org/wiki/redmine/Redminelnstall
e hitp://www.redmine.org/wiki/redmine/RedmineUpgrade

History

#1 - 02/15/2016 01:44 PM - Daniel Curtis

- Description updated

#2 - 02/15/2016 01:56 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress
#3 - 02/15/2016 02:16 PM - Daniel Curtis

- Description updated

#4 - 02/15/2016 05:54 PM - Daniel Curtis
- Description updated
#5 - 02/23/2016 02:41 PM - Daniel Curtis

- Description updated

#6 - 02/27/2016 09:39 PM - Daniel Curtis

- Description updated

#7 - 02/28/2016 01:20 PM - Daniel Curtis

- Description updated

#8 - 03/12/2016 02:02 PM - Daniel Curtis
- Description updated
